Three dimensional (3D) toric codes are a class of stabilizer codes with local checks and come under the umbrella of topological codes. While decoding algorithms have been proposed for the 3D toric code on a cubic lattice, there have been very few studies on the decoding of 3D toric codes over arbitrary lattices. Color codes in 3D can be mapped to toric codes. However, the resulting toric codes are not defined on cubic lattice. They are arbitrary lattices with triangular faces. Decoding toric codes over an arbitrary lattice will help in studying the performance of color codes. Furthermore, gauge color codes can also be decoded via 3D toric codes. Motivated by this, we propose an efficient algorithm to decode 3D toric codes on arbitrary lattices (with and without boundaries).
Three dimensional (3D) toric codes are a class of stabilizer codes with local checks and come under the umbrella of topological codes. While decoding algorithms have been proposed for the 3D toric code on a cubic lattice, there have been very few studies on the decoding of 3D toric codes over arbitrary lattices. Color codes in 3D can be mapped to toric codes. However, the resulting toric codes are not defined on cubic lattice. They are arbitrary lattices with triangular faces. Decoding toric codes over an arbitrary lattice will help in studying the performance of color codes. Furthermore, gauge color codes can also be decoded via 3D toric codes. Motivated by this, we propose an efficient algorithm to decode 3D toric codes on arbitrary lattices (with and without boundaries).
Recent years have seen a growing interest in quantum codes in three dimensions (3D). One of the earliest proposed 3D quantum codes is the 3D toric code. It has been shown that 3D color codes can be mapped to 3D toric codes. The 3D toric code on a cubic lattice is also a building block for the welded code which has the highest energy barrier to date. Although well known, the performance of the 3D toric code has not been studied extensively. In this paper we propose efficient decoding algorithms for the 3D toric code on a cubic lattice with and without boundaries and report their performance for various quantum channels. We observe a threshold of $\ensuremath{\gtrsim}12%$ for the bit flip errors, $\ensuremath{\approx}3%$ for the phase flip errors, and 24.8% for the erasure channel. We also study the performance of the welded 3D toric code on the quantum erasure channel. We did not observe a threshold for the welded code over the erasure channel for the parameters we simulated.
Toric codes and color codes are two important classes of topological codes. Kubica et al. [A. Kubica et al., New J. Phys. 17, 083026 (2015)] showed that any D-dimensional color code can be mapped to a finite number of toric codes in D dimensions. We propose an alternate map of three-dimensional (3D) color codes to 3D toric codes with a view to decoding 3D color codes. Our approach builds on Delfosse's result [N. Delfosse, Phys. Rev. A 89, 012317 (2014)] for 2D color codes and exploits the topological properties of these codes. Our result reduces the decoding of 3D color codes to that of 3D toric codes. Bit-flip errors are decoded by projecting on one set of 3D toric codes, while phase-flip errors are decoded by projecting onto another set of 3D toric codes. We use these projections to study the performance of a class of 3D color codes called stacked codes.
In quantum computers, each logical qubit must be encoded in several physical qubits to protect against noise in physical qubits. The tetrahedral color code is such an encoding. In the primal lattice, the three-dimensional tetrahedral color code is a bitruncated octahedral lattice, and in the dual lattice, the tetrahedral color code is a four-colorable body-centered cubic lattice. This color code can be utilized for measurement-based quantum computing, for which all entanglement is present in a cluster state at the beginning of the computation and gate operations are performed by local measurements and classical operations. Moreover, this color code admits a gate set that is both transversal, i.e., realized by qubit-wise operations, and universal when supplemented by measurement and classical computing. During cluster state preparation and computation, errors may occur on the physical qubits. Therefore, it is necessary to have a decoder that, using the syndrome of these errors, finds a set of qubits to correct and performs the operations needed to correct those qubits. The decoder is considered successful if and only if the correction does not cause a logical error on the logical qubit. In this thesis, I present a decoder for Pauli Z, or phase-flip, errors on the three-dimensional tetrahedral color code with nonperiodic boundaries. This decoder for Z-errors includes as a subroutine a decoder for Pauli X errors. The decoder uses a restriction procedure to map the tetrahedral color code to a toric code. The toric code is another quantum error correcting code. Then, an existing toric code decoder interprets the error syndrome. This research on the bounded color code builds upon previous work on the unbounded color code and the two-dimensional color code. Under independently identically distributed noise, evidence indicates an error probability threshold for Z-errors between 0.01% and 0.02% and for X-errors between 2.5% and 3.3%. I also present example errors and illustrate how the decoder attempts to correct those errors.
Research on mitigating errors in computing and communication systems has grown with their widespread use. In quantum computing, error correction is crucial as errors can quickly propagate, undermining results and the theoretical speedup over classical systems. Quantum error-correcting codes, particularly topological codes, are a key focus. These codes map parity check matrices to graphs on d-dimensional surfaces, with our research centered on the 3D toric code. Effective decoders must be robust to noise, with performance improving as code size increases, but their complexity should scale polynomially with lattice size for practicality. We propose a neural network with inductive bias, leveraging equivariance to generalize efficiently from a smaller input subset. Additionally, we explore transformer networks for error correction and compare these methods to existing techniques for decoding errors in the 3D toric code, highlighting their strengths and limitations.
Practical large-scale quantum computation requires both efficient error correction and robust implementation of logical operations. Three-dimensional (3D) color codes are a promising candidate for fault-tolerant quantum computation due to their transversal non-Clifford gates, but efficient decoding remains challenging. In this work, we extend previous decoders for two-dimensional color codes [1], which are based on the restriction of the decoding problem to a subset of the qubit lattice, to three dimensions. Including boundaries of 3D color codes, we demonstrate that the 3D restriction decoder achieves optimal scaling of the logical error rate and a threshold value of 1.55(6)% for code-capacity bit- and phase-flip noise, which is almost a factor of two higher than previously reported for this family of codes [2, 3]. We furthermore present qCodePlot3D, a Python package for visualizing 2D and 3D color codes, error configurations, and decoding paths, which supports the development and analysis of such decoders. These advancements contribute to making 3D color codes a more practical option for exploring fault-tolerant quantum computation.
We introduce an efficient decoder of the color code in d ≥ 2 dimensions, the Restriction Decoder, which uses any d -dimensional toric code decoder combined with a local lifting procedure to find a recovery operation. We prove that the Restriction Decoder successfully corrects errors in the color code if and only if the corresponding toric code decoding succeeds. We also numerically estimate the Restriction Decoder threshold for the color code in two and three dimensions against the bit-flip and phase-flip noise with perfect syndrome extraction. We report that the 2D color code threshold p 2D ≈ 10.2 % on the square-octagon lattice is on a par with the toric code threshold on the square lattice.